## c-munipack 2.1.38

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
cmake_policy(VERSION 3.18)

project("C-Munipack"
    LANGUAGES C CXX 
    VERSION 2.1.38 
    HOMEPAGE_URL http://c-munipack.sourceforge.net/
    DESCRIPTION "Astrophotometry software with focus on variable stars."
)

enable_testing()

set(CMAKE_C_STANDARD 90)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/Modules" ${CMAKE_MODULE_PATH})

set(CMUNIPACK_LIBRARY_NAME "cmpack20")

set(targets_export_name ${CMUNIPACK_LIBRARY_NAME}Targets CACHE INTERNAL "")

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

set(OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${OUTPUT_DIRECTORY})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${OUTPUT_DIRECTORY})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${OUTPUT_DIRECTORY})

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

if (MSVC)
    set(VSINSTALLDIR $ENV{VSINSTALLDIR} CACHE INTERNAL "")
    set(VCINSTALLDIR $ENV{VCINSTALLDIR} CACHE INTERNAL "")
endif(MSVC)

# Options
option(ENABLE_WCS "Enable support for WCS" ON)
option(ENABLE_TOOLKIT "Build and install command line tools" ON)
option(ENABLE_GUI "Build and install Muniwin - graphical user interface" ON)
option(ENABLE_TESTS "Build test suite." ON)
option(ENABLE_BUILD_DOC "Build manual and documentation" ON)
option(BUILD_SHARED_LIBS "Build shared libraries" ON)
if(WIN32)
    option(USE_INTERNAL_CFITSIO "Use internal cfitsio library" ON)
    option(USE_INTERNAL_ZLIB "Use internal zlib library" ON)
    option(USE_INTERNAL_EXPAT "Use internal expat library" ON)
    option(USE_EXTERNAL_FFTW3 "Use FFTW library" OFF)
else(WIN32)
    option(USE_INTERNAL_CFITSIO "Use internal cfitsio library" OFF)
    option(USE_INTERNAL_ZLIB "Use internal zlib library" OFF)
    option(USE_INTERNAL_EXPAT "Use internal expat library" OFF)
    option(USE_EXTENAL_FFTW3 "Use FFTW library" OFF)
endif(WIN32)

# Needed to include config.h
include_directories(${CMAKE_BINARY_DIR}/include)

# EXTERNAL DEPENDENCIES
# ---------------------

# M
if(UNIX AND NOT APPLE AND NOT BEOS AND NOT HAIKU AND NOT EMSCRIPTEN)
  find_library(M_LIBRARY m)
else()
  # libm is not needed and/or not available.
  set(M_LIBRARY "")
endif()

# ZLIB
if(USE_INTERNAL_ZLIB)
    message(STATUS "Using internal zlib library")
    add_subdirectory(thirdparty/zlib)
    add_library(cmpack_zlib ALIAS zlibstatic)
else(USE_INTERNAL_ZLIB)
    find_package(ZLIB REQUIRED)
    add_library(cmpack_zlib ALIAS ZLIB::ZLIB)
endif(USE_INTERNAL_ZLIB)

# CFITSIO
if(USE_INTERNAL_CFITSIO)
    message(STATUS "Using internal cfitsio library")
    add_subdirectory(thirdparty/cfitsio)
    add_library(cmpack_cfitsio ALIAS cfitsio)
else(CFITSIO REQUIRED)
    find_package(CFITSIO REQUIRED)
    add_library(cmpack_cfitsio ALIAS CFITSIO::CFITSIO)
endif(USE_INTERNAL_CFITSIO)

# EXPAT
if(USE_INTERNAL_EXPAT)
    message(STATUS "Using internal expat library")
    add_subdirectory(thirdparty/expat)
    add_library(cmpack_expat ALIAS expat)
else(USE_INTERNAL_EXPAT)
    find_package(EXPAT REQUIRED)
    add_library(cmpack_expat ALIAS EXPAT::EXPAT)
endif(USE_INTERNAL_EXPAT)

# WCSLIB
if(ENABLE_WCS)
    message(STATUS "Using internal wcslib library")
    add_subdirectory(thirdparty/wcslib)
    set(CMUNIPACK_HAVE_WCSLIB ON CACHE INTERNAL "")
    set(WCS_LIBRARY wcslib CACHE INTERNAL "")
else(ENABLE_WCS)
    set(CMUNIPACK_HAVE_WCSLIB OFF CACHE INTERNAL "")
    set(WCS_LIBRARY "" CACHE INTERNAL "")
endif(ENABLE_WCS)

# FFTPACK
if (USE_EXTENAL_FFTW3)
    find_package(FFTW3)
endif (USE_EXTENAL_FFTW3)
if (FFTW3_FOUND)
    set(CMUNIPACK_USE_FFTW 1)
    message(STATUS "Using FFTW")
else ()
    set(CMUNIPACK_USE_INTERNAL_FFTPACK 1)
    message(STATUS "Using internal fftpack library")
    add_subdirectory(thirdparty/fftpack)
    add_library(cmpack_fftpack ALIAS fftpack)
endif(FFTW3_FOUND)

# GTK
if(ENABLE_GUI)
    find_package(GTK2 2.8 REQUIRED gtk)
    if (WIN32)
        file(TO_CMAKE_PATH $ENV{GTK2_X64_ROOT} GTK2_ROOT)
    endif(WIN32)
endif(ENABLE_GUI)


# GLOBAL VARIABLES
# ----------------

if(UNIX AND NOT WIN32)
     get_filename_component(CMUNIPACK_INSTALL_DATADIR "${CMAKE_INSTALL_DATADIR}/${CMAKE_PROJECT_NAME}-${CMAKE_PROJECT_VERSION_MAJOR}.0" ABSOLUTE BASE_DIR "${CMAKE_INSTALL_PREFIX}" CACHE)
     add_compile_definitions(CMUNIPACK_INSTALL_DATADIR="${CMUNIPACK_INSTALL_DATADIR}")      
endif(UNIX AND NOT WIN32)

# CORE LIBRARY
# ------------

add_subdirectory(lib)

# COMMANDS (TOOLKIT)
# ------------------

if(ENABLE_TOOLKIT)
    add_subdirectory(toolkit)
endif(ENABLE_TOOLKIT)


# MUNIWIN (UI)
# ------------
if(ENABLE_GUI)
    add_subdirectory(muniwin)
endif(ENABLE_GUI)

# TESTS
# -----

if(ENABLE_TESTS)
    find_package(GTest CONFIG REQUIRED)
    add_library(gtest ALIAS GTest::gtest)
    add_library(gmock ALIAS GTest::gmock)
    include(GoogleTest)
endif(ENABLE_TESTS)


# DOCS & USER MANUAL
# ------------------

add_subdirectory(doc)


# CONFIGURATION FILES
# -------------------

file(WRITE ${CMAKE_BINARY_DIR}/VERSION ${CMAKE_PROJECT_VERSION})
if(UNIX AND NOT WIN32)
    install(FILES ${CMAKE_BINARY_DIR}/VERSION DESTINATION "${CMUNIPACK_INSTALL_DATADIR}")
else(UNIX AND NOT WIN32)
    install(FILES ${CMAKE_BINARY_DIR}/VERSION DESTINATION "${CMAKE_INSTALL_DATADIR}")
endif(UNIX AND NOT WIN32)

configure_file(${PROJECT_SOURCE_DIR}/cmake/config.h.in config.h)


# LICENCES
# --------

if(UNIX AND NOT WIN32)
    install(FILES COPYING LICENSE.CDDL LICENSE.GPL2 LICENSE.LGPL DESTINATION "${CMUNIPACK_INSTALL_DATADIR}")
else(UNIX AND NOT WIN32)
    install(FILES COPYING LICENSE.CDDL LICENSE.GPL2 LICENSE.LGPL DESTINATION "${CMAKE_INSTALL_DATADIR}")
endif(UNIX AND NOT WIN32)

# PACKAGING
# ---------

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

configure_file(${PROJECT_SOURCE_DIR}/cmake/NSISConfig.nsh.in NSISConfig.nsh @ONLY)

set(CPACK_PACKAGE_VENDOR "David Motl")
set(CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CMAKE_PROJECT_VERSION}-x64")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "${CMAKE_PROJECT_NAME}-${CMAKE_PROJECT_VERSION_MAJOR}.${CMAKE_PROJECT_VERSION_MINOR}")
set(CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}/muniwin/src/muniwin.ico")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
set(CPACK_MONOLITHIC_INSTALL ON)
set(CPACK_STRIP_FILES ON)

set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CMAKE_PROJECT_VERSION}-source")
set(CPACK_SOURCE_IGNORE_FILES "/.git/" "/.vs/" "/out/")

if(WIN32)
  set(CPACK_GENERATOR "NSIS")
  set(CPACK_SOURCE_GENERATOR "ZIP")
endif(WIN32)

include(CPack)

=== doc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

# Import library that includes ctxhelp.h
add_library(manual INTERFACE)
target_include_directories(manual INTERFACE "src/include")

# User manual
if(ENABLE_BUILD_DOC)
	find_package(Sphinx REQUIRED)

	set(output_dir "${CMAKE_BINARY_DIR}/share/manual/en/html")
	set(SPHINX_OUTPUT_DIRECTORY ${output_dir} PARENT_SCOPE)

	set(SPHINX_EXTENSIONS sphinx.ext.imgmath html2)
	set(SPHINX_AUTHOR "David Motl")
	sphinx_add_docs(
	  muniwin_manual
	  BUILDER html 
	  SOURCE_DIRECTORY src
	  EXTENSION_FILES "src/ext/html2.py"
	  OUTPUT_DIRECTORY ${output_dir}
	)

	set_target_properties(muniwin_manual PROPERTIES FOLDER doc)

	if(UNIX AND NOT WIN32)
		install(DIRECTORY "${output_dir}" DESTINATION "${CMUNIPACK_INSTALL_DATADIR}/manual/en")
	else(UNIX AND NOT WIN32)
		install(DIRECTORY "${output_dir}" DESTINATION "${CMAKE_INSTALL_DATADIR}/manual/en")
	endif(UNIX AND NOT WIN32)

endif(ENABLE_BUILD_DOC)

=== lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated" CACHE INTERNAL "")

#
# PUBLIC HEADERS
# --------------
#
set(cmpack_public_headers
include/cmpack_adcurve.h
include/cmpack_allfile.h
include/cmpack_amass.h
include/cmpack_astro.h
include/cmpack_bias.h
include/cmpack_catfile.h
include/cmpack_ccdfile.h
include/cmpack_common.h
include/cmpack_config.h
include/cmpack_console.h
include/cmpack_dark.h
include/cmpack_flat.h
include/cmpack_fset.h
include/cmpack_hcorr.h
include/cmpack_image.h
include/cmpack_kombine.h
include/cmpack_konve.h
include/cmpack_lcurve.h
include/cmpack_match.h
include/cmpack_mbias.h
include/cmpack_mdark.h
include/cmpack_mfind.h
include/cmpack_mflat.h
include/cmpack_phot.h
include/cmpack_phtfile.h
include/cmpack_readall.h
include/cmpack_table.h
include/cmpack_tcorr.h
include/cmpack_tcurve.h
include/cmpack_wcs.h
include/cmunipack.h
)


#
# PRIVATE HEADERS
# ---------------

set(cmpack_private_headers
src/allimport.h
src/attach.h
src/catfile.h
src/ccdfile.h
src/center.h
src/cholesky.h
src/comfun.h
src/console.h
src/cr3.h
src/crx.h
src/fft.h
src/filter.h
src/find.h
src/fotometr.h
src/frameset.h
src/hash.h
src/header.h
src/image.h
src/imageheader.h
src/iost.h
src/konvcr3.h
src/konvcrw.h
src/konvfits.h
src/konvmrw.h
src/konvnef.h
src/konvoes.h
src/konvsbig.h
src/linsolver.h
src/list.h
src/match.h
src/matfun.h
src/matphilnr.h
src/matread.h
src/matsimple.h
src/matsolve.h
src/matstack.h
src/matwrite.h
src/mem.h
src/oesfile.h
src/phfun.h
src/phot.h
src/phtfile.h
src/phwrite.h
src/qrdecomp.h
src/robmean.h
src/sky.h
src/sort.h
src/stars.h
src/strutils.h
src/table.h
src/tabparser.h
src/trajd.h
src/wcsobj.h
src/xmldom.h
)


#
# SOURCES
#
set(cmpack_sources
${cmpack_public_headers}
${cmpack_private_headers}
src/adcurve.c
src/allimport.c
src/amass.c
src/attach.c
src/bias.c
src/catfile.c
src/ccdfile.c
src/center.c
src/cholesky.c
src/comfun.c
src/common.c
src/console.c
src/cr3.c
src/crx.c
src/dark.c
src/fft.c
src/filter.c
src/find.c
src/flat.c
src/fotometr.c
src/frameset.c
src/hash.c
src/hcorr.c
src/header.c
src/image.c
src/imageheader.c
src/iost.c
src/kombine.c
src/konvcr3.c
src/konvcrw.c
src/konve.c
src/konvfits.c
src/konvmrw.c
src/konvnef.c
src/konvoes.c
src/konvsbig.c
src/lcurve.c
src/linsolver.c
src/list.c
src/match.c
src/matfun.c
src/matphilnr.c
src/matread.c
src/matsimple.c
src/matsolve.c
src/matstack.c
src/matwrite.c
src/mbias.c
src/mdark.c
src/mem.c
src/mfind.c
src/mflat.c
src/oesfile.c
src/phfun.c
src/phot.c
src/phtfile.c
src/phwrite.c
src/plot.c
src/qrdecomp.c
src/robmean.c
src/sky.c
src/sort.c
src/stars.c
src/strutils.c
src/table.c
src/tabparser.c
src/tcorr.c
src/tcurve.c
src/trajd.c
src/wcsobj.c
src/xmldom.c
)

if (MSVC)
    # to distinguish between debug and release lib
    set(CMAKE_DEBUG_POSTFIX "d")

    add_library(libcmpack SHARED ${cmpack_sources})

    # msvc does not append 'lib' - do it here to have consistent name
    set_target_properties(libcmpack PROPERTIES OUTPUT_NAME ${CMUNIPACK_LIBRARY_NAME})
    set_target_properties(libcmpack PROPERTIES PREFIX "lib")
    set_target_properties(libcmpack PROPERTIES IMPORT_PREFIX "lib")
    target_compile_definitions(libcmpack PRIVATE _CRT_SECURE_NO_DEPRECATE _CRT_SECURE_NO_WARNINGS _NO_OLDNAMES)
    target_compile_definitions(libcmpack PUBLIC CMUNIPACK_BUILD_SHARED_LIB)
    target_compile_options(libcmpack PRIVATE /W3 /WX)
    target_compile_options(libcmpack PRIVATE -D__STDC__=1)
  
else (MSVC)

    add_library(libcmpack SHARED ${cmpack_sources})
    target_compile_definitions(libcmpack PUBLIC CMUNIPACK_BUILD_SHARED_LIB)
    set_property(TARGET libcmpack PROPERTY POSITION_INDEPENDENT_CODE 1)
    set_target_properties(libcmpack PROPERTIES OUTPUT_NAME "${CMUNIPACK_LIBRARY_NAME}")

endif(MSVC)

target_include_directories(libcmpack PUBLIC 
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include;${generated_dir};${CMAKE_BINARY_DIR}>" 
    "$<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>"
)
set_target_properties(libcmpack PROPERTIES FOLDER lib)
set_target_properties(libcmpack PROPERTIES C_STANDARD 99)
target_link_libraries(libcmpack PRIVATE cmpack_zlib cmpack_cfitsio cmpack_expat ${WCS_LIBRARY} ${M_LIBRARY})

if (CMUNIPACK_USE_FFTW)
    target_link_libraries(libcmpack PRIVATE FFTW3::fftw3)
elseif (CMUNIPACK_USE_INTERNAL_FFTPACK)
    target_link_libraries(libcmpack PRIVATE fftpack)
endif(CMUNIPACK_USE_FFTW)

# Install the project targets.
install(TARGETS libcmpack EXPORT ${targets_export_name})

install(FILES ${cmpack_public_headers} TYPE INCLUDE)

# Install PDBs
if (MSVC)
    install(FILES $<TARGET_PDB_FILE:libcmpack> 
        CONFIGURATIONS "RelWithDebInfo" "Debug" 
        TYPE BIN
        OPTIONAL
    )
endif(MSVC)

# DOCUMENTATION
# -------------

add_subdirectory(doc)


# CONFIGURATION FILES
# -------------------

configure_file(cmake/cmpack_version.h.in ${generated_dir}/cmpack_version.h)
install(FILES "${generated_dir}/cmpack_version.h" TYPE INCLUDE)

# INSTALL
# -------

# Needed to set the namespace for both the export targets and the
# alias libraries

set(version_file "${generated_dir}/${CMUNIPACK_LIBRARY_NAME}ConfigVersion.cmake")
write_basic_package_version_file(${version_file} VERSION ${PROJECT_VERSION} COMPATIBILITY AnyNewerVersion)

set(cmake_files_install_dir "${CMAKE_INSTALL_LIBDIR}/cmake/${CMUNIPACK_LIBRARY_NAME}-${PROJECT_VERSION}")
install(EXPORT ${targets_export_name} NAMESPACE ${CMUNIPACK_LIBRARY_NAME}:: DESTINATION ${cmake_files_install_dir})

set(config_file "${generated_dir}/${CMUNIPACK_LIBRARY_NAME}Config.cmake")
configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/Config.cmake.in" 
    "${config_file}" INSTALL_DESTINATION ${cmake_files_install_dir})

install(FILES ${version_file} ${config_file} 
    DESTINATION ${cmake_files_install_dir}
)

# Configure and install pkgconfig files.
set(configured_pc "${generated_dir}/${CMUNIPACK_LIBRARY_NAME}.pc")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/${CMUNIPACK_LIBRARY_NAME}.pc.in" "${configured_pc}" @ONLY)

install(FILES "${configured_pc}" 
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

=== muniwin/CMakeLists.txt ===
set(muniwin_headers
src/about_dlg.h
src/addfiles_dlg.h
src/addfilter_dlg.h
src/addfolder_dlg.h
src/airmass_dlg.h
src/amasscurve_dlg.h
src/biascorr_dlg.h
src/callback.h
src/catfile_class.h
src/catfile_dlg.h
src/ccdfile_class.h
src/ccdfile_dlg.h
src/ccdtempcurve_dlg.h
src/chart_dlg.h
src/chooseaperture_dlg.h
src/choosestars_dlg.h
src/colorchooser_dlg.h
src/configuration.h
src/convert_dlg.h
src/darkcorr_dlg.h
src/editselections_dlg.h
src/export_aavso.h
src/export_baavss.h
src/export_dlgs.h
src/export_options.h
src/express_dlg.h
src/file_classes.h
src/file_dlg.h
src/findvariables_dlg.h
src/flatcorr_dlg.h
src/frameinfo_dlg.h
src/frameset_class.h
src/frame_dlg.h
src/graph_toolbox.h
src/helcor_dlg.h
src/helper_classes.h
src/helper_dlgs.h
src/image_class.h
src/infobox.h
src/info_dlg.h
src/jdconv_dlg.h
src/lightcurve_dlg.h
src/locations.h
src/main.h
src/main_dlg.h
src/makecatalogfile_dlg.h
src/masterbias_dlg.h
src/masterdark_dlg.h
src/masterflat_dlg.h
src/matching_dlg.h
src/matching_mt.h
src/matching_st.h
src/measurement.h
src/menubar.h
src/merge_dlg.h
src/messages_dlg.h
src/newfiles_dlg.h
src/objects.h
src/objects_dlg.h
src/object_dlg.h
src/objproperties_dlg.h
src/observer_dlg.h
src/output_dlg.h
src/photometry2_dlg.h
src/photometry_dlg.h
src/phot_class.h
src/phtfile_dlg.h
src/popup.h
src/preferences_dlg.h
src/preview.h
src/proc_classes.h
src/profile.h
src/profiles_dlg.h
src/profile_editor.h
src/progress_dlg.h
src/project.h
src/project_dlg.h
src/qphot.h
src/senddumpfiles.h
src/showheader_dlg.h
src/showwcsdata_dlg.h
src/sound.h
src/table_class.h
src/table_dlg.h
src/thumbnails_dlg.h
src/timecorr_dlg.h
src/toolbar.h
src/trackcurve_dlg.h
src/utils.h
src/varcat.h
src/varfind.h
src/varfindfile_dlg.h
)

set(muniwin_sources 
${muniwin_headers}
src/about_dlg.cpp
src/addfiles_dlg.cpp
src/addfilter_dlg.cpp
src/addfolder_dlg.cpp
src/airmass_dlg.cpp
src/amasscurve_dlg.cpp
src/biascorr_dlg.cpp
src/callback.cpp
src/catfile_class.cpp
src/catfile_dlg.cpp
src/ccdfile_class.cpp
src/ccdfile_dlg.cpp
src/ccdtempcurve_dlg.cpp
src/chart_dlg.cpp
src/chooseaperture_dlg.cpp
src/choosestars_dlg.cpp
src/colorchooser_dlg.cpp
src/configuration.cpp
src/convert_dlg.cpp
src/darkcorr_dlg.cpp
src/editselections_dlg.cpp
src/export_aavso.cpp
src/export_baavss.cpp
src/export_dlgs.cpp
src/export_options.cpp
src/express_dlg.cpp
src/file_classes.cpp
src/file_dlg.cpp
src/findvariables_dlg.cpp
src/flatcorr_dlg.cpp
src/frameinfo_dlg.cpp
src/frameset_class.cpp
src/frame_dlg.cpp
src/graph_toolbox.cpp
src/helcor_dlg.cpp
src/helper_classes.cpp
src/helper_dlgs.cpp
src/image_class.cpp
src/infobox.cpp
src/info_dlg.cpp
src/jdconv_dlg.cpp
src/lightcurve_dlg.cpp
src/locations.cpp
src/main.cpp
src/main_dlg.cpp
src/makecatalogfile_dlg.cpp
src/masterbias_dlg.cpp
src/masterdark_dlg.cpp
src/masterflat_dlg.cpp
src/matching_dlg.cpp
src/matching_mt.cpp
src/matching_st.cpp
src/measurement.cpp
src/menubar.cpp
src/merge_dlg.cpp
src/messages_dlg.cpp
src/newfiles_dlg.cpp
src/objects.cpp
src/objects_dlg.cpp
src/object_dlg.cpp
src/objproperties_dlg.cpp
src/observer_dlg.cpp
src/output_dlg.cpp
src/photometry2_dlg.cpp
src/photometry_dlg.cpp
src/phot_class.cpp
src/phtfile_dlg.cpp
src/popup.cpp
src/preferences_dlg.cpp
src/preview.cpp
src/proc_classes.cpp
src/profile.cpp
src/profiles_dlg.cpp
src/profile_editor.cpp
src/progress_dlg.cpp
src/project.cpp
src/project_dlg.cpp
src/qphot.cpp
src/showheader_dlg.cpp
src/showwcsdata_dlg.cpp
src/sound.cpp
src/table_class.cpp
src/table_dlg.cpp
src/thumbnails_dlg.cpp
src/timecorr_dlg.cpp
src/toolbar.cpp
src/trackcurve_dlg.cpp
src/utils.cpp
src/varcat.cpp
src/varfind.cpp
src/varfindfile_dlg.cpp
)

set(muniwin_libraries 
	libcmpack
	cmpack_widgets 
	manual 
	GTK2::gtk 
	cmpack_cfitsio
	cmpack_expat
	${M_LIBRARY}
)

add_subdirectory(widgets)

add_executable(muniwin WIN32 ${muniwin_sources})
set_target_properties(muniwin PROPERTIES FOLDER muniwin)
target_link_libraries(muniwin PUBLIC ${muniwin_libraries})

if(WIN32)
	configure_file(src/muniwin.rc.in muniwin.rc @ONLY)
	configure_file(src/muniwin.ico muniwin.ico COPYONLY)
	target_sources(muniwin PRIVATE muniwin.rc)
endif(WIN32)


if(MSVC)
	target_link_libraries(muniwin PRIVATE htmlhelp.lib winmm.lib)
	target_compile_options(muniwin PRIVATE /wd4311)
else(MSVC)
	target_compile_options(muniwin PRIVATE -Wdeprecated-declarations)
endif(MSVC)

file(GLOB_RECURSE resource_icons res/icons/*.png)
file(GLOB_RECURSE resource_sounds res/sounds/*.wav)

add_custom_target(resources ALL 
	COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_BINARY_DIR}/share/icons
	COMMAND ${CMAKE_COMMAND} -E copy_if_different ${resource_icons} ${CMAKE_BINARY_DIR}/share/icons
	COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_BINARY_DIR}/share/sounds
	COMMAND ${CMAKE_COMMAND} -E copy_if_different ${resource_sounds} ${CMAKE_BINARY_DIR}/share/sounds
	COMMENT "Copying resource files ..."
	SOURCES ${resource_files}
)
set_target_properties(resources PROPERTIES FOLDER utils)

# Install executable
install(TARGETS muniwin)

# Install PDBs
if (MSVC)
    install(FILES $<TARGET_PDB_FILE:muniwin> 
        CONFIGURATIONS "RelWithDebInfo" "Debug" 
        TYPE BIN
        OPTIONAL
    )
endif(MSVC)

# Install resources
if(UNIX AND NOT WIN32)
	install(FILES ${resource_icons} DESTINATION "${CMUNIPACK_INSTALL_DATADIR}/icons")
	install(FILES ${resource_sounds} DESTINATION "${CMUNIPACK_INSTALL_DATADIR}/sounds")
else(UNIX AND NOT WIN32)
	install(FILES ${resource_icons} DESTINATION "${CMAKE_INSTALL_DATADIR}/icons")
	install(FILES ${resource_sounds} DESTINATION "${CMAKE_INSTALL_DATADIR}/sounds")
endif(UNIX AND NOT WIN32)

if(WIN32)
	# GTK binaries
	set(gtk2_runtime_dependencies)
	foreach(f ${GTK2_LIBRARIES} expat.lib fontconfig.lib freetype.lib intl.lib pangowin32-1.0.lib png14.lib zlib1.lib)
		get_filename_component(fname ${f} NAME_WLE)
		find_file(gtk2_lib${fname}_dll NAMES lib${fname}-0.dll lib${fname}-1.dll lib${fname}-2.dll lib${fname}-3.dll lib${fname}-4.dll lib${fname}-5.dll 
			lib${fname}-6.dll lib${fname}-7.dll lib${fname}-8.dll lib${fname}-9.dll lib${fname}-10.dll lib${fname}-11.dll lib${fname}-12.dll 
			lib${fname}-13.dll lib${fname}-14.dll ${fname}.dll PATHS ${GTK2_ROOT}/bin)
		if (gtk2_lib${fname}_dll)
			list(APPEND gtk2_runtime_dependencies ${gtk2_lib${fname}_dll})
		else()
			message(STATUS "The Gtk shared library ${fname} was not found.")
		endif()
	endforeach()
	# Install dependencies
	install(FILES ${gtk2_runtime_dependencies} TYPE BIN)
	# Install Gtk configuration file
	install(FILES "${GTK2_ROOT}/share/themes/ms-windows/gtk-2.0/gtkrc" DESTINATION "${CMAKE_INSTALL_SYSCONFDIR}/gtk-2.0")
	# Find optional Gtk modules
	set(gtk2_runtime_modules)
	file(GLOB gtk2_runtime_modules "${GTK2_ROOT}/lib/gtk-2.0/2.10.0/engines/*.dll")
	install(FILES ${gtk2_runtime_modules} DESTINATION "${CMAKE_INSTALL_LIBDIR}/gtk-2.0/2.10.0/engines")
endif(WIN32)

=== toolkit/CMakeLists.txt ===
include(cmake/internal_utils.cmake)

set(toolkit_common_source 
	src/cmdline.c 
	src/cmdline.h 
	src/utils.c 
	src/utils.h 
	src/cfgfile.c 
	src/cfgfile.h
)

set(toolkit_tools
	airmass 
	autoflat 
	biasbat 
	darkbat 
	flatbat 
	helcor 
	kombine 
	konve 
	meanbias 
	meandark 
	munifind 
	munilist 
	munimatch 
	muniphot 
	timebat
)

add_library(toolkit_common OBJECT ${toolkit_common_source})
set_target_properties(toolkit_common PROPERTIES FOLDER toolkit)
target_link_libraries(toolkit_common PUBLIC libcmpack)

set(toolkit_libraries toolkit_common)

foreach(t ${toolkit_tools})
	add_toolkit_target(${t} src/${t}.c src/${t}.rc)
endforeach()

=== lib/doc/CMakeLists.txt ===
add_subdirectory(doxygen)
add_subdirectory(manpages)

=== lib/tests/CMakeLists.txt ===
set(tests_headers
comfun.h
xmldom.h
)

set(tests_sources
${tests_headers}
main.cpp
amass_test.cpp
bias_test.cpp
catfile_test.cpp
ccdfile_test.cpp
comfun.cpp
common_test.cpp
dark_test.cpp
flat_test.cpp
fset_test.cpp
helcor_test.cpp
kombine_test.cpp
konve_test.cpp
list_test.cpp
main.cpp
match_test.cpp
mbias_test.cpp
mdark_test.cpp
mflat_test.cpp
phot_test.cpp
phtfile_test.cpp
table_test.cpp
tcorr_test.cpp
xmldom.cpp
xml_test.cpp
)

set(tests_libs
cmpack_static
)

if(ENABLE_TESTS)

	add_executable(tests ${tests_sources})
	set_target_properties (tests PROPERTIES FOLDER tests/core)
	target_compile_options(tests PRIVATE /W3 /WX)
	target_link_libraries(tests PRIVATE ${tests_libs} gtest gmock cmpack_cfitsio cmpack_expat)

	gtest_discover_tests(tests)

	if(MSVC)
		target_compile_definitions(tests PRIVATE _CRT_SECURE_NO_DEPRECATE _CRT_SECURE_NO_WARNINGS _NO_OLDNAMES)
	endif(MSVC)

endif(ENABLE_TESTS)

=== muniwin/widgets/CMakeLists.txt ===
set(cmpack_widgets_public_headers
include/cmpack_chart_data.h
include/cmpack_chart_view.h
include/cmpack_curve_plot.h
include/cmpack_entity.h
include/cmpack_graph_data.h
include/cmpack_graph_view.h
include/cmpack_image_data.h
include/cmpack_preview.h
include/cmpack_scale.h
include/cmpack_time_scale_data.h
include/cmpack_time_scale_view.h
include/cmpack_widgdefs.h
include/cmpack_widgets.h
)

set(cmpack_widgets_private_headers
)

set(cmpack_widgets_sources 
${cmpack_widgets_public_headers}
${cmpack_widgets_private_headers}
src/cmpack_chart_data.cpp
src/cmpack_chart_view.cpp
src/cmpack_curve_plot.cpp
src/cmpack_entity.cpp
src/cmpack_graph_data.cpp
src/cmpack_graph_view.cpp
src/cmpack_image_data.cpp
src/cmpack_preview.cpp
src/cmpack_scale.cpp
src/cmpack_time_scale_data.cpp
src/cmpack_time_scale_view.cpp
)

set(cmpack_widgets_libraries 
libcmpack 
GTK2::gtk
)

add_library(cmpack_widgets OBJECT ${cmpack_widgets_sources})
set_target_properties(cmpack_widgets PROPERTIES FOLDER muniwin)
target_link_libraries(cmpack_widgets PUBLIC ${cmpack_widgets_libraries})
target_include_directories(cmpack_widgets PUBLIC include)

=== thirdparty/cfitsio/CMakeLists.txt ===
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}")
set (LIB_DESTINATION "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
set (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/")

# Define project version
SET(${PROJECT_NAME}_MAJOR_VERSION 3)
SET(${PROJECT_NAME}_MINOR_VERSION 49)
SET(${PROJECT_NAME}_VERSION ${${PROJECT_NAME}_MAJOR_VERSION}.${${PROJECT_NAME}_MINOR_VERSION})
SET(LIB_NAME cfitsio)

# Microsoft Visual Studio:
IF(MSVC OR BORLAND)
    # Define
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
    # Need an empty unistd.h in MSVC for flex-generated eval_l.c:
    FILE(WRITE ${CMAKE_SOURCE_DIR}/unistd.h "")
    INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR})
ENDIF()

IF(BORLAND)
    # Suppress spurious Borland compiler warnings about "Suspicious
    # pointer arithmetic", "Possibly incorrect assignment", and
    # "Comparing signed and unsigned values".
    ADD_DEFINITIONS(-w-spa)
    ADD_DEFINITIONS(-w-pia)
    ADD_DEFINITIONS(-w-csu)
ENDIF()

SET (LIB_TYPE STATIC)
IF (BUILD_SHARED_LIBS)
  SET (LIB_TYPE SHARED)
ENDIF (BUILD_SHARED_LIBS)

FILE(GLOB H_FILES "*.h")

SET(SRC_FILES
    buffers.c cfileio.c checksum.c
    drvrfile.c drvrmem.c drvrnet.c
    editcol.c edithdu.c eval_f.c eval_l.c eval_y.c
    f77_wrap1.c f77_wrap2.c f77_wrap3.c f77_wrap4.c
    fits_hcompress.c fits_hdecompress.c fitscore.c
    getcol.c getcolb.c getcold.c getcole.c getcoli.c getcolj.c getcolk.c
    getcoll.c getcols.c getcolsb.c getcolui.c getcoluj.c getcoluk.c
    getkey.c group.c grparser.c histo.c imcompress.c iraffits.c modkey.c
    pliocomp.c
    putcol.c putcolb.c putcold.c putcole.c putcoli.c putcolj.c putcolk.c
    putcoll.c putcols.c putcolsb.c putcolu.c putcolui.c putcoluj.c putcoluk.c
    putkey.c quantize.c region.c ricecomp.c scalnull.c simplerng.c swapproc.c
    wcssub.c wcsutil.c zlib/zcompress.c zlib/zuncompress.c
)

# Only include zlib source files if we are building a shared library.
# Users will need to link their executable with zlib independently.
IF (BUILD_SHARED_LIBS)
    set(SRC_FILES ${SRC_FILES}
        zlib/adler32.c zlib/crc32.c zlib/deflate.c zlib/infback.c
        zlib/inffast.c zlib/inflate.c zlib/inftrees.c zlib/trees.c
        zlib/uncompr.c zlib/zutil.c
        )
ENDIF()

ADD_LIBRARY(${LIB_NAME} ${LIB_TYPE} ${H_FILES} ${SRC_FILES})
TARGET_LINK_LIBRARIES(${LIB_NAME} ${M_LIB})
target_include_directories(${LIB_NAME} PUBLIC 
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>" 
    "$<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>")
set_target_properties(${LIB_NAME} PROPERTIES FOLDER thirdparty)

# Install the project targets.
install(TARGETS ${LIB_NAME} EXPORT ${targets_export_name})

if(MSVC)
	target_compile_options(${LIB_NAME} PRIVATE /wd4311 /wd4312)
endif()

=== thirdparty/expat/CMakeLists.txt ===
set(EXPAT_SHARED_LIBS ${BUILD_SHARED_LIBS})

#
# Configuration
#
set(EXPAT_CONTEXT_BYTES 1024 CACHE STRING "Define to specify how much context to retain around the current parse point")
mark_as_advanced(EXPAT_CONTEXT_BYTES)
option(EXPAT_DTD "Define to make parameter entity parsing functionality available" ON)
mark_as_advanced(EXPAT_DTD)
option(EXPAT_NS "Define to make XML Namespaces functionality available" ON)
mark_as_advanced(EXPAT_NS)
option(EXPAT_WARNINGS_AS_ERRORS "Treat all compiler warnings as errors" OFF)
if(UNIX OR _EXPAT_HELP)
    option(EXPAT_DEV_URANDOM "Define to include code reading entropy from `/dev/urandom'." ON)
    set(EXPAT_WITH_GETRANDOM "AUTO" CACHE STRING
            "Make use of getrandom function (ON|OFF|AUTO) [default=AUTO]")
    set(EXPAT_WITH_SYS_GETRANDOM "AUTO" CACHE STRING
            "Make use of syscall SYS_getrandom (ON|OFF|AUTO) [default=AUTO]")
    mark_as_advanced(EXPAT_DEV_URANDOM)
endif()
set(EXPAT_CHAR_TYPE "char" CACHE STRING "Character type to use (char|ushort|wchar_t) [default=char]")
option(EXPAT_ATTR_INFO "Define to allow retrieving the byte offsets for attribute names and values" OFF)
mark_as_advanced(EXPAT_ATTR_INFO)
option(EXPAT_LARGE_SIZE "Make XML_GetCurrent* functions return <(unsigned) long long> rather than <(unsigned) long>" OFF)
mark_as_advanced(EXPAT_LARGE_SIZE)
option(EXPAT_MIN_SIZE "Get a smaller (but slower) parser (in particular avoid multiple copies of the tokenizer)" OFF)
mark_as_advanced(EXPAT_MIN_SIZE)
if(MSVC OR _EXPAT_HELP)
    set(EXPAT_MSVC_STATIC_CRT OFF CACHE BOOL "Use /MT flag (static CRT) when compiling in MSVC")
endif()

if(MSVC)
    # For the three types of MSVC version values, please see:
    # - https://cmake.org/cmake/help/latest/variable/MSVC_VERSION.html
    # - https://sourceforge.net/p/predef/wiki/Compilers/
    # - https://en.wikipedia.org/wiki/Microsoft_Visual_Studio#History
    set(_EXPAT_MSVC_REQUIRED_INT 1800)  # i.e. 12.0/2013/1800; see PR #426
    set(_EXPAT_MSVC_SUPPORTED_INT 1910)
    set(_EXPAT_MSVC_SUPPORTED_DISPLAY "Visual Studio 15.0/2017/${_EXPAT_MSVC_SUPPORTED_INT}")

    if(MSVC_VERSION VERSION_LESS ${_EXPAT_MSVC_SUPPORTED_INT})
        if(MSVC_VERSION VERSION_LESS ${_EXPAT_MSVC_REQUIRED_INT})
            message(SEND_ERROR "MSVC_VERSION ${MSVC_VERSION} is TOO OLD to compile Expat without errors.")
            message(SEND_ERROR "Please use officially supported ${_EXPAT_MSVC_SUPPORTED_DISPLAY} or later.  Thank you!")
        else()
            message(WARNING "MSVC_VERSION ${MSVC_VERSION} is NOT OFFICIALLY SUPPORTED by Expat.")
            message(WARNING "Please use ${_EXPAT_MSVC_SUPPORTED_DISPLAY} or later.  Thank you!")
        endif()
    endif()
endif()

macro(_expat_copy_bool_int source_ref dest_ref)
    if(${source_ref})
        set(${dest_ref} 1)
    else()
        set(${dest_ref} 0)
    endif()
endmacro()

if(EXPAT_LARGE_SIZE)
    add_definitions(-DXML_LARGE_SIZE)
endif()

if(EXPAT_MIN_SIZE)
    add_definitions(-DXML_MIN_SIZE)
endif()

if(EXPAT_CHAR_TYPE STREQUAL "char")
    set(_EXPAT_UNICODE OFF)
    set(_EXPAT_UNICODE_WCHAR_T OFF)
elseif(EXPAT_CHAR_TYPE STREQUAL "ushort")
    set(_EXPAT_UNICODE ON)
    set(_EXPAT_UNICODE_WCHAR_T OFF)
elseif(EXPAT_CHAR_TYPE STREQUAL "wchar_t")
    set(_EXPAT_UNICODE ON)
    set(_EXPAT_UNICODE_WCHAR_T ON)
    if(NOT WIN32)
        string(FIND "${CMAKE_C_FLAGS}" "-fshort-wchar" _expat_short_wchar_found)
        if(${_expat_short_wchar_found} EQUAL "-1")
            message(SEND_ERROR "Configuration -DEXPAT_CHAR_TYPE=wchar_t requires -DCMAKE_{C,CXX}_FLAGS=-fshort-wchar (which was not found) and libc compiled with -fshort-wchar, too.")
        endif()
    endif()
else()
    message(SEND_ERROR "Option -DEXPAT_CHAR_TYPE=(char|ushort|wchar_t) cannot be \"${EXPAT_CHAR_TYPE}\".")
endif()

if(_EXPAT_UNICODE)
    add_definitions(-DXML_UNICODE)              # for unsigned short
    if(_EXPAT_UNICODE_WCHAR_T)
        add_definitions(-DXML_UNICODE_WCHAR_T)  # for wchar_t
    endif()
endif()

include(${CMAKE_CURRENT_LIST_DIR}/ConfigureChecks.cmake)

macro(evaluate_detection_results use_ref have_ref thing_lower thing_title)
    if(${use_ref} AND NOT (${use_ref} STREQUAL "AUTO") AND NOT ${have_ref})
        message(SEND_ERROR
                "Use of ${thing_lower} was enforced by ${use_ref}=ON but it could not be found.")
    elseif(NOT ${use_ref} AND ${have_ref})
        message("${thing_title} was found but it will not be used due to ${use_ref}=OFF.")
        set(${have_ref} 0)
    endif()
endmacro()

if(NOT WIN32)
    evaluate_detection_results(EXPAT_WITH_GETRANDOM HAVE_GETRANDOM "function getrandom" "Function getrandom")
    evaluate_detection_results(EXPAT_WITH_SYS_GETRANDOM HAVE_SYSCALL_GETRANDOM "syscall SYS_getrandom" "Syscall SYS_getrandom")
endif()

_expat_copy_bool_int(EXPAT_ATTR_INFO        XML_ATTR_INFO)
_expat_copy_bool_int(EXPAT_DTD              XML_DTD)
_expat_copy_bool_int(EXPAT_LARGE_SIZE       XML_LARGE_SIZE)
_expat_copy_bool_int(EXPAT_MIN_SIZE         XML_MIN_SIZE)
_expat_copy_bool_int(EXPAT_NS               XML_NS)
if(NOT WIN32)
    _expat_copy_bool_int(EXPAT_DEV_URANDOM  XML_DEV_URANDOM)
endif()
set(XML_CONTEXT_BYTES ${EXPAT_CONTEXT_BYTES})


configure_file(expat_config.h.cmake "${CMAKE_CURRENT_BINARY_DIR}/expat_config.h")

set(EXTRA_COMPILE_FLAGS)
if(FLAG_NO_STRICT_ALIASING)
    set(EXTRA_COMPILE_FLAGS "${EXTRA_COMPILE_FLAGS} -fno-strict-aliasing")
endif()
if(FLAG_VISIBILITY)
  add_definitions(-DXML_ENABLE_VISIBILITY=1)
  set(EXTRA_COMPILE_FLAGS "${EXTRA_COMPILE_FLAGS} -fvisibility=hidden")
endif()
if(MINGW)
    # Without __USE_MINGW_ANSI_STDIO the compiler produces a false positive
    set(EXTRA_COMPILE_FLAGS "${EXTRA_COMPILE_FLAGS} -Wno-pedantic-ms-format")
endif()
if (EXPAT_WARNINGS_AS_ERRORS)
    if(MSVC)
        add_definitions(/WX)
    else()
        set(EXTRA_COMPILE_FLAGS "${EXTRA_COMPILE_FLAGS} -Werror")
    endif()
endif()
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_COMPILE_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_COMPILE_FLAGS}")

if (MSVC)
    if (EXPAT_MSVC_STATIC_CRT)
        message("-- Using static CRT ${EXPAT_MSVC_STATIC_CRT}")
        foreach(flag_var
                CMAKE_CXX_FLAGS_DEBUG
                CMAKE_CXX_FLAGS_RELEASE
                CMAKE_CXX_FLAGS_MINSIZEREL
                CMAKE_CXX_FLAGS_RELWITHDEBINFO
                CMAKE_C_FLAGS_DEBUG
                CMAKE_C_FLAGS_RELEASE
                CMAKE_C_FLAGS_MINSIZEREL
                CMAKE_C_FLAGS_RELWITHDEBINFO
                )
            string(REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
        endforeach()
    endif()
endif()

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/lib)
if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS -wd4996)
endif()
if(WIN32)
    if(_EXPAT_UNICODE_WCHAR_T)
        set(_POSTFIX_WIDE "w")
    endif()

    if(MSVC AND NOT EXPAT_SHARED_LIBS)
        if(EXPAT_MSVC_STATIC_CRT)
            set(_POSTFIX_CRT "MT")
        else()
            set(_POSTFIX_CRT "MD")
        endif()
    endif()

    foreach(postfix_var
            CMAKE_DEBUG_POSTFIX
            CMAKE_RELEASE_POSTFIX
            CMAKE_MINSIZEREL_POSTFIX
            CMAKE_RELWITHDEBINFO_POSTFIX
            )
        if(postfix_var STREQUAL "CMAKE_DEBUG_POSTFIX")
            set(_POSTFIX_DEBUG "d")
        else()
            set(_POSTFIX_DEBUG "")
        endif()

        set(${postfix_var} "${_POSTFIX_WIDE}${_POSTFIX_DEBUG}${_POSTFIX_CRT}" CACHE STRING "Windows binary postfix, e.g. libexpat<postfix=[w][d][MD|MT]>.lib")
    endforeach()
endif()

#
# C library
#
set(expat_SRCS
    lib/xmlparse.c
    lib/xmlrole.c
    lib/xmltok.c
# NOTE: ISO C forbids an empty translation unit
#   lib/xmltok_impl.c
#   lib/xmltok_ns.c
)

if(EXPAT_SHARED_LIBS)
    set(_SHARED SHARED)
    if(MSVC)
        set(expat_SRCS ${expat_SRCS} lib/libexpat.def)
    endif()
else()
    set(_SHARED STATIC)
endif()

# Avoid colliding with Expat.dll of Perl's XML::Parser::Expat
if(WIN32 AND NOT MINGW)
    set(_EXPAT_OUTPUT_NAME libexpat)  # CMAKE_*_POSTFIX applies, see above
else()
    if(_EXPAT_UNICODE)
        set(_EXPAT_OUTPUT_NAME expatw)
    else()
        set(_EXPAT_OUTPUT_NAME expat)
    endif()
endif()

add_library(expat ${_SHARED} ${expat_SRCS})
if(EXPAT_WITH_LIBBSD)
    target_link_libraries(expat ${LIB_BSD})
endif()

set(LIBCURRENT 9)   # sync
set(LIBREVISION 1)  # with
set(LIBAGE 8)       # configure.ac!
math(EXPR LIBCURRENT_MINUS_AGE "${LIBCURRENT} - ${LIBAGE}")

set_property(TARGET expat PROPERTY OUTPUT_NAME "${_EXPAT_OUTPUT_NAME}")
if(NOT WIN32)
    set_property(TARGET expat PROPERTY VERSION ${LIBCURRENT_MINUS_AGE}.${LIBAGE}.${LIBREVISION})
    set_property(TARGET expat PROPERTY SOVERSION ${LIBCURRENT_MINUS_AGE})
    set_property(TARGET expat PROPERTY NO_SONAME ${NO_SONAME})
endif()

target_include_directories(expat
    INTERFACE
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

if(NOT EXPAT_SHARED_LIBS AND WIN32)
    target_compile_definitions(expat PUBLIC -DXML_STATIC)
endif()

install(TARGETS expat EXPORT ${targets_export_name})

=== thirdparty/fftpack/CMakeLists.txt ===
#
# PRIVATE HEADERS
# ---------------

set(fftpack_private_headers f2c.h)

#
# SOURCES
#
set(fftpack_sources
${fftpack_private_headers}
cfftb.c 
cfftb1.c 
cfftf.c 
cfftf1.c 
cffti.c 
cffti1.c 
cosqb.c 
cosqb1.c 
cosqf.c 
cosqf1.c 
cosqi.c 
cost.c 
costi.c 
ezfft1.c 
ezfftb.c 
ezfftf.c 
ezffti.c 
passb.c 
passb2.c 
passb3.c 
passb4.c 
passb5.c 
passf.c 
passf2.c 
passf3.c 
passf4.c 
passf5.c 
radb2.c 
radb3.c 
radb4.c 
radb5.c 
radbg.c 
radf2.c 
radf3.c 
radf4.c 
radf5.c 
radfg.c 
rfftb.c 
rfftb1.c 
rfftf.c 
rfftf1.c 
rffti.c 
rffti1.c 
sinqb.c 
sinqf.c 
sinqi.c 
sint.c 
sint1.c 
sinti.c 
)

add_library(fftpack OBJECT ${fftpack_sources})
set_target_properties(fftpack PROPERTIES FOLDER thirdparty)
set_target_properties(fftpack PROPERTIES C_STANDARD 99)
set_target_properties(fftpack PROPERTIES POSITION_INDEPENDENT_CODE ON)

if(MSVC)
    target_compile_options(fftpack PRIVATE /W3 /WX)
endif(MSVC)

=== thirdparty/wcslib/CMakeLists.txt ===
#
# SOURCES
#
set(wcslib_sources
C/cel.c
C/dis.c
C/flexed/wcsbth.c
C/flexed/wcspih.c
C/flexed/wcsulex.c
C/flexed/wcsutrn.c
C/lin.c
C/log.c
C/prj.c
C/spc.c
C/sph.c
C/spx.c
C/tab.c
C/wcs.c
C/wcserr.c
C/wcsfix.c
C/wcshdr.c
C/wcsprintf.c
C/wcstrig.c
C/wcsunits.c
C/wcsutil.c
)

add_library(wcslib OBJECT ${wcslib_sources})
set_target_properties(wcslib PROPERTIES FOLDER thirdparty)
set_target_properties(wcslib PROPERTIES C_STANDARD 99)
set_target_properties(wcslib PROPERTIES POSITION_INDEPENDENT_CODE ON)

target_include_directories(wcslib PUBLIC
	"$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/C;${CMAKE_CURRENT_SOURCE_DIR}>"
	"$<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>"
)

if(MSVC)
	target_compile_definitions(wcslib PRIVATE _CRT_SECURE_NO_DEPRECATE _CRT_SECURE_NO_WARNINGS _NO_OLDNAMES YY_NO_UNISTD_H)
	target_compile_options(wcslib PRIVATE -D__STDC__=1)
	target_compile_options(wcslib PRIVATE /W3)
	target_compile_options(wcslib PRIVATE /wd4005 /wd4244 /wd4267)
endif()

target_link_libraries(wcslib PRIVATE ${M_LIBRARY})

=== debian/changelog ===
c-munipack (2.1.38-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: bump standard to 4.7.2 (no changes)

 -- Thorsten Alteholz <debian@alteholz.de>  Thu, 14 Aug 2025 10:18:25 +0200

=== debian/control ===
Source: c-munipack
Section: science
Priority: optional
Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper-compat (= 13)
	, cmake
	, zlib1g-dev
	, libcfitsio-dev
	, libexpat1-dev
	, wcslib-dev
	, libgstreamer1.0-dev
	, libgtk2.0-dev
	, doxygen
	, libgtest-dev
	, libgmock-dev
	, python3-sphinx
Standards-Version: 4.7.2
Homepage: https://c-munipack.sourceforge.net/
#Vcs-Browser: https://salsa.debian.org/debian/c-munipack
#Vcs-Git: https://salsa.debian.org/debian/c-munipack.git
Vcs-Browser: https://salsa.debian.org/debian-astro-team/c-munipack
Vcs-Git: https://salsa.debian.org/debian-astro-team/c-munipack.git
Rules-Requires-Root: no

Package: c-munipack
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
	, c-munipack-share (= ${source:Version})
	, libcmpack20 (= ${binary:Version})
Description: reduction of images carried out by CCD camera
 This package contains software, which offers the complete solution for
 reduction of images carried out by CCD camera, intended on a observation
 of variable stars. Each step of reduction process can be run from the
 command line or via simple and intuitive graphical user interface.

Package: c-munipack-share
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: reduction of images carried out by CCD camera (share)
 This package contains software, which offers the complete solution for
 reduction of images carried out by CCD camera, intended on a observation
 of variable stars. Each step of reduction process can be run from the
 command line or via simple and intuitive graphical user interface.
 .
 This package contains arch independent files.

Package: libcmpack20
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: reduction of images carried out by CCD camera (library)
 This package contains software, which offers the complete solution for
 reduction of images carried out by CCD camera, intended on a observation
 of variable stars. Each step of reduction process can be run from the
 command line or via simple and intuitive graphical user interface.
 .
 This package contains the library.

Package: libcmpack-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: reduction of images carried out by CCD camera (development)
 This package contains software, which offers the complete solution for
 reduction of images carried out by CCD camera, intended on a observation
 of variable stars. Each step of reduction process can be run from the
 command line or via simple and intuitive graphical user interface.
 .
 This package contains files for development.

#Package: libcmpack-doc
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}
#Description: reduction of images carried out by CCD camera (documentation)
# This package contains software, which offers the complete solution for
# reduction of images carried out by CCD camera, intended on a observation
# of variable stars. Each step of reduction process can be run from the
# command line or via simple and intuitive graphical user interface.
# .
# This package contains documentation.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON

override_dh_install:
	#find
	rm debian/tmp/usr/share/C-Munipack-2.0/COPYING
	rm debian/tmp/usr/share/C-Munipack-2.0/LICENSE.CDDL
	rm debian/tmp/usr/share/C-Munipack-2.0/LICENSE.GPL2
	rm debian/tmp/usr/share/C-Munipack-2.0/LICENSE.LGPL
	rmdir debian/tmp/usr/share/C-Munipack-2.0/manual/en/html/_images/math/
	dh_install

## c-munipack 2.1.39

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 project("C-Munipack"
     LANGUAGES C CXX 
-    VERSION 2.1.38 
+    VERSION 2.1.39
     HOMEPAGE_URL http://c-munipack.sourceforge.net/
     DESCRIPTION "Astrophotometry software with focus on variable stars."
 )

=== debian/changelog ===
c-munipack (2.1.39-2) unstable; urgency=medium

  * disable GUI (Closes: #1052193)
    (GUI will be enabled again after upstream finished porting to GTK3)

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 14 Feb 2026 18:48:26 +0100

c-munipack (2.1.39-1) unstable; urgency=medium

  * New upstream release.

 -- Thorsten Alteholz <debian@alteholz.de>  Thu, 08 Jan 2026 19:48:26 +0100

=== debian/control ===
--- 
+++ 
@@ -10,11 +10,12 @@
 	, libexpat1-dev
 	, wcslib-dev
 	, libgstreamer1.0-dev
-	, libgtk2.0-dev
 	, doxygen
 	, libgtest-dev
 	, libgmock-dev
 	, python3-sphinx
+# no longer depend on obsolete gtk2
+#	, libgtk2.0-dev
 Standards-Version: 4.7.2
 Homepage: https://c-munipack.sourceforge.net/
 #Vcs-Browser: https://salsa.debian.org/debian/c-munipack

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON
+	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON -DENABLE_GUI=OFF
 
 override_dh_install:
 	#find
